import string
import pygame
from pygame.locals import *


from pykitten.engine import State



class BaseState(State):
    def __init__(self):
        State.__init__(self)
        self.screen = pygame.display.get_surface()
        self.background = pygame.Surface(self.screen.get_size())
        self.buttons = {}

    def add_button(self, name, btn):
        self.buttons[name] = btn
        self.widgets.append(btn)

class BgState(BaseState):
    #state that gets background image (i.e. last state's screen)

    def __init__(self, bg):
        BaseState.__init__(self)
        if bg is None:
            bg = pygame.Surface(pygame.display.get_surface().get_size())
        self.background = bg.copy()
        self.upd = 1

    def update_screen(self):
        if self.upd:
            self.upd = 0
            self.screen.blit(self.background, (0,0))
            pygame.display.flip()

    def add_textentry_events(self, entry):
        keys = []
        keys.extend(string.ascii_lowercase)
        keys.extend(string.digits)

        for k in keys:
            self.add_kbevent(KEYDOWN,eval("K_"+k),entry.add_text,char=k)

        self.add_kbevent(KEYDOWN, K_BACKSPACE, entry.rem_text)
        self.add_kbevent(KEYDOWN, K_RETURN, self.submit)

    def submit(self):
        pass
