#all game resources like graphics, sounds and levels


import pygame
from pygame.locals import K_UP, K_DOWN, K_LEFT, K_RIGHT, K_1, K_2, K_3, K_4

from pykitten.data import *


GFX = {}
SFX = {}
TMP = {}
SAVE = {}
JB = JukeBox(["levelbgm.xm"])

def load_gfx():
    colkey = (255,128,255)

    #map tiles - named after filename without the ".png" ending
    filenames = [
        "cataway.png",
        "catnip.png",
        "corner.png",
        "cross.png",
        "dot.png",
        "end.png",
        "long.png",
        "tjunct.png",
    ]

    folder = "tiles/"
    for f in filenames:
        GFX[f[:-4]] = load_image(folder+f, colorkey=colkey)

    #transformed tiles
    GFX["long1"] = pygame.transform.rotate(GFX["long"], 90)
    GFX["corner1"] = pygame.transform.flip(GFX["corner"], True, False)
    GFX["corner2"] = pygame.transform.rotate(GFX["corner"], -90)
    GFX["corner3"] = pygame.transform.flip(GFX["corner2"], True, False)
    GFX["end1"] = pygame.transform.flip(GFX["end"], True, False)
    GFX["end2"] = pygame.transform.rotate(GFX["end"], 90)
    GFX["end3"] = pygame.transform.flip(GFX["end2"], False, True)
    GFX["tjunct1"] = pygame.transform.flip(GFX["tjunct"], False, True)
    GFX["tjunct2"] = pygame.transform.rotate(GFX["tjunct"], 90)
    GFX["tjunct3"] = pygame.transform.flip(GFX["tjunct2"], True, False)

    #cat ghosts - named "g0", "g1", etc.
    filenames = [
        "catblue.png",
        "catbrown.png",
        "catgreen.png",
        "catpurple.png",
        "catred.png",
    ]

    nr = 0
    folder = "ghosts/"
    for f in filenames:
        GFX["g"+str(nr)] = load_image(folder+f, colorkey=colkey)
        nr += 1

    GFX["ghost"] = load_image(folder+"catblue_nonum.png", colorkey=colkey)
    GFX["catglow"] = load_image(folder+"catglow.png", colorkey=colkey)

    #cat eyes - named "up", "down", "left", "right"
    filenames = {
        "up" : "cateyes_up.png",
        "down" : "cateyes_down.png",
        "left" : "cateyes_left.png",
        "right" : "cateyes_right.png",
    }

    for k in filenames.keys():
        GFX[k] = load_image(folder+filenames[k], colorkey=colkey)


    #pacdog
    filenames = [
        "pacdog1.png",
        "pacdog2.png",
        "pacdog3.png",
        "pacdog4.png",
    ]


    dog_right = []
    folder = "pacdog/"
    GFX["pacdog-img"] = load_image(folder+"pacdog1.png", colorkey=colkey)

    for f in filenames:  #mouth opening anim
        dog_right.append(load_image(folder+f, colorkey=colkey))

    for i in xrange(3,0,-1): #append mouth clothing anim
        dog_right.append(dog_right[i])

    dog_left = []
    for img in dog_right:
        dog_left.append(pygame.transform.flip(img, True, False))

    dog_up = []
    for img in dog_right:
        dog_up.append(pygame.transform.rotate(img, 90))

    dog_down = []
    for img in dog_right:
        dog_down.append(pygame.transform.rotate(img, -90))

    GFX["pacdog"] = [dog_down, dog_up, dog_left, dog_right]

    #dark pacdog
    filenames = [
        "dpacdog1.png",
        "dpacdog2.png",
        "dpacdog3.png",
        "dpacdog4.png",
    ]


    dog_right = []
    folder = "pacdog/"
    for f in filenames:  #mouth opening anim
        dog_right.append(load_image(folder+f, colorkey=colkey))

    for i in xrange(3,1,-1): #append mouth clothing anim
        dog_right.append(dog_right[i])

    dog_left = []
    for img in dog_right:
        dog_left.append(pygame.transform.flip(img, True, False))

    dog_up = []
    for img in dog_right:
        dog_up.append(pygame.transform.rotate(img, 90))

    dog_down = []
    for img in dog_right:
        dog_down.append(pygame.transform.rotate(img, -90))

    glow = []
    tmp = load_image(folder+"pacglow.png",colorkey=colkey)
    gright = tmp
    gleft = pygame.transform.flip(tmp, True, False)
    gup = pygame.transform.rotate(tmp, 90)
    gdown = pygame.transform.rotate(tmp, -90)
    GFX["glowdog"] = [gdown, gup, gleft, gright]
    GFX["dpacdog"] = [dog_down, dog_up, dog_left, dog_right]


    filenames = [
        "btn_credits",
        "btn_editor",
        "btn_exit",
        "btn_freeplay",
        "btn_help",
        "btn_highscore",
        "btn_resume",
        "btn_start",
        "btn_back",
    ]

    folder = "btn/"
    for f in filenames:
        for i in xrange(1,4):
            name = f + str(i) + ".png"
            GFX[name[:-4]] = load_image(folder+name, colorkey=colkey)

    GFX["btn_down1"] = load_image(folder+"btn_down1.png", colorkey=colkey)
    GFX["btn_down2"] = load_image(folder+"btn_down2.png", colorkey=colkey)
    GFX["btn_up1"] = load_image(folder+"btn_up1.png", colorkey=colkey)
    GFX["btn_up2"] = load_image(folder+"btn_up2.png", colorkey=colkey)

    GFX["sel_cus1"] = load_image(folder+"sel_cus1.png", colorkey=colkey)
    GFX["sel_cus2"] = load_image(folder+"sel_cus2.png", colorkey=colkey)
    GFX["sel_camp1"] = load_image(folder+"sel_camp1.png", colorkey=colkey)
    GFX["sel_camp2"] = load_image(folder+"sel_camp2.png", colorkey=colkey)

    GFX["mode_cat"] = load_image(folder+"mode_cat.png", colorkey=colkey)
    GFX["mode_dog"] = load_image(folder+"mode_dog.png", colorkey=colkey)


    filenames = [
        "eyes_d.png",
        "eyes_dl.png",
        "eyes_dr.png",
        "eyes_l.png",
        "eyes_r.png",
        "eyes_u.png",
        "eyes_ul.png",
        "eyes_ur.png",
    ]

    folder="eyes/"
    for f in filenames:
        GFX[f[:-4]] = load_image(folder+f, colorkey=colkey)


    filenames = [
        "levelsel.png",
        "lose.png",
        "win.png",
        "main.png",
        "help.png",
        "credits.png",
    ]

    folder="menus/"
    for f in filenames:
        GFX[f[:-4]] = load_image(folder+f, colorkey=colkey)

    #GENERATED PLACEHOLDER GRAPHICS
    GFX["ground"] = pygame.Surface((32,32))
    GFX["ground"].fill((0,0,0))


def load_savegame():

    save = load_object("save.dat")

    if save:
        for k in save.keys():
            SAVE[k] = save[k]
    else:
        SAVE["cur"] = {
            #"level": 0,
            #"score": 0,
            #"name": "Nanji",
            #"lives": 3
        }

        SAVE["camphigh"] = {
            #mapname : [("name", score), ("name", score), ("name", score)]
        }

        SAVE["custhigh"] = {
            #mapname : [(name, score), (name, score), (name, score)]
        }

        SAVE["pachighca"] = {
            #mapname : [(name, score), (name, score), (name, score)]
        }
        SAVE["pachighcu"] = {
            #mapname : [(name, score), (name, score), (name, score)]
        }

        SAVE["overhigh"] = [
            ("nekochan", 100, 0),
            ("evilguy", 200, 0),
            ("guy", 400, 0),
            ("johnny", 600, 0),
            ("catfoodinc", 800, 0),
            ("whitepaw", 1000, 0),
            ("kuroneko", 2000, 0),
            ("C.A.T.B.O.T.", 4000, 0),
            ("nanji", 6000, 0),
            ("matatabi", 8000, 0),
        ]

        SAVE["unlock"] = 0
        save_data()

    #~ SAVE["cur"]["level"] = 14
    #~ SAVE["cur"]["name"] = "Cheater"
    #~ SAVE["cur"]["score"] = 0
    #~ SAVE["cur"]["lives"] = 3

    #TODO: look for unuseable scores (i.e. map not found)
    #on startup and delete them.

def load_all():
    load_gfx()
    load_savegame()
    TMP["last_key"] = None
    TMP["play_keys"] = [K_UP, K_DOWN, K_LEFT, K_RIGHT, K_1, K_2, K_3, K_4]

def save_data():
    filename = "save.dat"
    try:
        save_object(SAVE, filename)
    except:
        print "Could not save to", filename



